(function ($, Drupal) {
  Drupal.behaviors.imageSizesBehavior = {
    attach: function (context, settings) {
      $('img.image-sizes', context).once('imageSizesBehaviorLoad').each(function () {
        if (!$(this).data('image-sizes')) {
          $(this).data('image-sizes', JSON.parse($(this).attr('data-src')));
        }
        $(this).on('image:size-check', function() {
          imageSizesSetUrl(this);
        });
      });
      $('img.image-sizes.load-always', context).each(function(){
        $(this).trigger('image:size-check');
      })
      let resizeObserver = new ResizeObserver((entries, observer) => {
        for (entry of entries) {
          $(entry.target).find('img.image-sizes').trigger('image:size-check');
        }
      });
      $('img.image-sizes.load-always').each(function() {
        resizeObserver.observe($(this).parent().get(0));
      })
      $(context).once('image-observer').each(function(){
        let observer = new IntersectionObserver((entries, imageObserver) => {
          entries.forEach((entry) => {
            if (entry.isIntersecting) {
              imageObserver.unobserve(entry.target);
              resizeObserver.observe($(entry.target).parent().get(0))
            }
          })
        });
        $('img.image-sizes:not(.load-always)', context).each(function(){
          observer.observe(this);
        })
      })

    }
  };
  function imageSizesSetUrl(ele) {
    var width = $(ele).parent().width();
    var conf = $(ele).data('image-sizes');
    var newUrl = false;
    var a;
    for ( var a in conf ) {
      newUrl = conf[a];
      if (a >= width) {
        break;
      }
    }
    if (width > a || newUrl == false) {
      newUrl = $(ele).attr('data-src-fallback');
    }
    if (newUrl !== ele.src) {
      let img = new Image();
      $(ele).addClass('loading');
      $(img).on('load', function() {
        $(ele).removeClass('pre-load').removeClass('loading').addClass('fade-in-on-load');
        ele.src = this.src;
        $(ele).attr('width', img.naturalWidth);
        $(ele).attr('height', img.naturalHeight);
        $(ele).trigger('image:size-checked');
        delete this;
      });

      img.src = newUrl;
    }
  }
})(jQuery, Drupal);
